#ifndef CIVDBCONN_H
#define CIVDBCONN
#include "CivTypes.h"
#include "CivAssembly.h"
#include "CivTableTemp.h"

#define DBEXPORT __declspec(dllexport)

/**
   ݿӽӿ
*/
class DBEXPORT  CivDbConn
{
public:
	CivDbConn();
	virtual ~CivDbConn();

	// ȡ
	virtual bool getNode(CivNode& node)=0;
	virtual bool getPipe(CivPipe& pipe)=0;
	virtual bool getTank(CivTank& tank)=0;
	virtual bool getValve(CivValve& valve)=0;
	virtual bool getPumps(CivPumps& pump)=0;
	virtual bool getReservoirs(CivReservoirs& reservoirs)=0;
	virtual bool getEmitters(CivEmitters& emitter)=0;
	virtual bool getCoordinates(CivCoordinates& coord)=0;
	virtual bool getMixing(CivMixing& mixing)=0;
	virtual bool getParameter(CivParameter& params)=0;
	virtual bool getPatterns(std::vector<CivPatterns>& patterns)=0;
	virtual bool getCurves(CivCurves& curves)=0;
	virtual bool getDemands(CivDemands& demands)=0;
	virtual bool getSources(CivSources& sources)=0;
	virtual bool getStatus(CivStatus& status)=0;
	virtual bool getQuality(CivQuality& quality)=0;
	virtual bool getLabels(CivLabels& labels)=0;
	virtual bool getTags(CivTags& tags)=0;

	/**
	*@brief ݿ⣬йʵ
	*/
	virtual bool open() = 0;

	/**
	*@brief رݿӣйʵ
	*/
	virtual void close() = 0;

	/**
	*@brief жĳűǷڣжϷݿйأӳٵʵ
	*@tableName: 
	*/
	virtual bool tableExist(StrQuote tableName) = 0;

	/**
	 *@brief 
	 *@tableName: 
	 *@schema:
	 *@tableType߽ͣ
	 */
	bool createTable(CivTableTemp& temp);

	bool isValid() const;


private:
	/**
	 *@brief ȡݣߣڵ㣬ˮԴȣ
	 *@tableName 
	 */
	Componets getComponets(StrQuote tableName);

	Componets getComponetsByWhere(StrQuote tableName, StrQuote where);

	/**
	 *@brief  ˮã (ڵתΪ)
	 *@tableName 
	 */
	Componets getLikelyPipes(StrQuote tableName);

	/**
	*@brief ֵֶɾ
	*@table
	*@filedNameֶ
	*@fieldValueֵֶ
	*/
	bool deleteByField(StrQuote table, StrQuote filedName, StrQuote fieldValue);

	bool updateNodeByInterval(StrQuote currDate, StrQuote interval);

	bool updateLinkByInterval(StrQuote currDate, StrQuote interval);
	/**
	 *@brief µ
	 *@nodeItemsҪµֵ
	 */
	bool updateNode(const NodeResultItems& nodeItems);

	/**
	 *@brief ߱
	 *@lineItems: 
	 */
	bool updateLink(const LinkResultItems& lineItems);

	// ӹֵֶ
	void addFilter(Str type, Str number);

	// ȡ˼
	FiledFilter getFilter() const;

	// ȡǰִдϢ
	Str getLastError() const;

	/**
	 *@brief codeֵѰ
	 *@table: ߱
	 *@code: code
	 */
	Componets getValueByCode(StrQuote table, StrQuote code);

	/**
	 *@brief ִsql
	 *@sql: Ҫִеsql
	 */
	virtual bool execSql(Str sql) = 0;

	/**
	*@brief ѯ
	*/
	virtual void clearResult() = 0;

	/**
	 *@brief Ӳѯȡ
	 *@result: ѯ
	 *@comp: 
	 */
	virtual void getData(Componets& comp) = 0;

protected:
	bool mIsOpen = false; // ݿϢ
	char* mLastError; // ִsqlĴϢ

private:	
	FiledFilter mFilter; // :Ӧı
};


#endif // !CIVDBCONN_H

